


uniform mat4 u_m44ModelViewProjection;
uniform mat4 u_m44Model;

uniform mat3 u_m33ProjectionDeck;
uniform mat3 u_m33ProjectionGrip;

attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;

varying vec2 v_v2TexCoord;
varying vec3 v_v3WorldPosition;
varying vec2 v_v2TexProjectionDeck;
varying vec2 v_v2TexProjectionGrip;

void main() 
{
	
	
	v_v2TexProjectionDeck = (u_m33ProjectionDeck * vec3(a_v4Position.xz, 1)).xy;
	v_v2TexProjectionGrip = (u_m33ProjectionGrip * vec3(a_v4Position.xz, 1)).xy;
    v_v2TexProjectionGrip.y = -v_v2TexProjectionGrip.y; 
	
	
	v_v2TexCoord = a_v2TexCoord;
	gl_Position = u_m44ModelViewProjection * a_v4Position;
	
	v_v3WorldPosition = (u_m44Model * a_v4Position).xyz;
}
