



uniform mat4 u_m44ModelViewProjection;

uniform mat3 u_m33SpecularRotation;


attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;
attribute vec3 a_v3Normal;

attribute vec2 a_v2TexCoord2;
attribute vec4 a_v4Color;


varying mediump vec2 v_v2TexCoord;

varying mediump vec2 v_v2TexCoordSignage;
varying lowp vec4 v_v4SignageModifier;






varying mediump vec3 v_v3Reflection;
uniform mediump vec3 u_v3EyePosition;


void main() 
{
	v_v2TexCoord = a_v2TexCoord;

	v_v2TexCoordSignage = a_v2TexCoord2;
	v_v4SignageModifier = a_v4Color * (1.0 / 255.0);


	gl_Position = u_m44ModelViewProjection * a_v4Position;




	vec3 v3Normal = a_v3Normal * u_m33SpecularRotation;			
	mediump vec3 v3Incident = a_v4Position.xyz * u_m33SpecularRotation - u_v3EyePosition;
	mediump vec3 v3Reflection = v3Incident - 2.0 * dot(v3Incident, v3Normal) * v3Normal / dot(v3Normal, v3Normal);		
	v_v3Reflection = v3Reflection;

}



